/*
 * conv.c - Ѵ⥸塼
 *    Mon, Aug 11 1997 by Kouichi ABE (WALL)
 */
#include <stdio.h>
#include <sys/types.h>

#include "kanji.h"
#include "wkf.h"
#include "jiscodemap.h"
#include "euccodemap.h"
#include "sjiscodemap.h"
#include "kanacodemap.h"
#include "zenasciimap.h"

/*
 * ɽؿ
 */
static StateJIS GetStateOfJIS();

/*
 * ؿ̾:	KanjiCodeConvTo
 * ǽ:	Ѵ󥿥ե
 * :	Ѵɡϴ(C_UNKNOWN ξϼưȽ)
 *		ϥե롦ݥ󥿡ϥե롦ݥ
 * :	Ѵ(TRUE) or Ѵʤ(FALSE)
 */
Boolean KanjiCodeConvTo(kcode, gcode, in, out)
	KanjiCode	kcode, gcode;
	register FILE	*in, *out;
{
  if (gcode == C_UNKNOWN) {
    gcode = GuessKanjiCode(kcode, in, out);	/* ϴɤưȽ */
  }
  else {
    NoPreRead(in);
  }

  switch (kcode) {			/* ϴ˽ʬ	*/
    case C_NEWJIS:			/* ϴɤ JIS 	*/
      switch (gcode) {
	case C_OLDJIS:
	case C_NEWJIS:
	case C_JIS1990:
	  jis2jis(out);
	  return TRUE;
#ifdef	CODE_EUC
	case C_EUCorSJIS:
#endif	/* CODE_EUC */
	case C_EUC:
	  euc2jis(out);
	  return TRUE;
#ifdef	CODE_SJIS
	case C_EUCorSJIS:
#endif	/* CODE_SJIS */
	case C_SJIS:
	  sjis2jis(out);
	  return TRUE;
	case C_ASCII:
	  NoConv(out);
	  return FALSE;
	default:
	  (void)fprintf(stderr, "Warning: No convert: input file may be binary or directory...\n");
	  return FALSE;
      }
    case C_EUC:			/* ϴɤܸ EUC 	*/
      switch (gcode) {
	case C_OLDJIS:
	case C_NEWJIS:
	case C_JIS1990:
	  jis2euc(out);
	  return TRUE;
#ifdef	CODE_EUC
	case C_EUCorSJIS:
#endif	/* CODE_EUC */
	case C_EUC:
	  euc2euc(out);
	  return TRUE;
#ifdef	CODE_SJIS
	case C_EUCorSJIS:
#endif	/* CODE_SJIS */
	case C_SJIS:
	  sjis2euc(out);
	  return TRUE;
	case C_ASCII:
	  NoConv(out);
	  return FALSE;
	default:
	  (void)fprintf(stderr, "Warning: No convert: input file may be binary or directory...\n");
	  return FALSE;
      }
    case C_SJIS:			/* ϴɤ SJIS 	*/
      switch (gcode) {
	case C_OLDJIS:
	case C_NEWJIS:
	case C_JIS1990:
	  jis2sjis(out);
	  return TRUE;
#ifdef	CODE_EUC
	case C_EUCorSJIS:
#endif	/* CODE_EUC */
	case C_EUC:
	  euc2sjis(out);
	  return TRUE;
#ifdef	CODE_SJIS
	case C_EUCorSJIS:
#endif	/* CODE_SJIS */
	case C_SJIS:
	  sjis2sjis(out);
	  return TRUE;
	case C_ASCII:
	  NoConv(out);
	  return FALSE;
	default:
	  (void)fprintf(stderr, "Warning: No convert: input file may be binary or directory...\n");
	  return FALSE;
      }
    case C_UNKNOWN:
      switch (gcode) {
	case C_UNKNOWN:
	  (void)fprintf(stdout, "unknown\n");
	  return TRUE;
	case C_EUCorSJIS:
	  (void)fprintf(stdout, "euc or sjis\n");
	  return TRUE;
	case C_ASCII:
	  (void)fprintf(stdout, "ascii\n");
	  return TRUE;
	case C_OLDJIS:
	  (void)fprintf(stdout, "oldjis\n");
	  return TRUE;
	case C_NEWJIS:
	  (void)fprintf(stdout, "newjis\n");
	  return TRUE;
	case C_JIS1990:
	  (void)fprintf(stdout, "jis1990\n");
	  return TRUE;
	case C_EUC:
	  (void)fprintf(stdout, "euc\n");
	  return TRUE;
	case C_SJIS:
	  (void)fprintf(stdout, "sjis\n");
	  return TRUE;
      }
    default:
      /* ˤʤ	*/
      break;
  }
  return FALSE;	/* ˤʤ	*/
}

/*
 * ؿ̾:	GetStateOfJIS
 * ǽ:	JIS ɤθߤξ֤֤
 * :	ʤ
 * :	֥
 */
static StateJIS GetStateOfJIS(void)
{
  int		c;
  StateJIS	state = JS_ESC;

  while ((c = GetChar()) != EOF) {
    switch (state) {
      case JS_ESC:
	if (c == '$') {
	  state = JS_JIS_2BYTE;
	}
	else if (c == '(') {
	  state = JS_JIS_1BYTE;
	}
	else if (c == '&') {
	  state = JS_JISX0208_1990_1;
	}
	break;
      case JS_JIS_1BYTE:
	if ((c == 'J') || (c == 'B')) {
	  return JS_ASCII;
	}
	else if (c == 'I') {
	  return JS_JIS8;
	}
	break;
      case JS_JIS_2BYTE:
	if ((c == '@') || (c == 'B')) {
	  return JS_JIS_2BYTE;
	}
	break;
      case JS_JISX0208_1990_1:
	if (c == '@') {
	  state = JS_JISX0208_1990_2;
	}
	break;
      case JS_JISX0208_1990_2:
	if (c == ESC) {
	  state = JS_ESC;
	}
	break;
      default:
	return JS_JIS_2BYTE;
    }
  }
  return JS_JIS_2BYTE;
}

/*
 * ؿ̾:	jis2euc
 * ǽ:	JIS ɤܸ EUC ɤѴ
 * :	ϥե롦ݥ
 * :	ʤ
 */
void jis2euc(fp)
	register FILE	*fp;
{
  int		c, c1, c2;
  StateJIS	state = JS_ASCII;

  while ((c = GetChar()) != EOF) {
    if (c == ESC) {	/* ץ󥹤ν	*/
      state = GetStateOfJIS();
      continue;
    }
    if (c == SO) {	/* Shift Out ν		*/
      state = JS_JIS7;
      c = GetChar();
    }
    else if (c == SI) {	/* Shift In ν		*/
      state = JS_ASCII;
    }
    switch (state) {
      case JS_ASCII:
	if (c == LF) {
	  (void)fputs(lineend, fp);
	}
	else {
	  (void)fputc(c, fp);
	}
	break;
      case JS_JIS_2BYTE:
	c1 = c;
	c2 = GetChar();
	if (zen2ascii && (jis2code_map[c1] == 0x03)) {
	  (void)fputc((int)zen2ascii_map[jis2code_map[c2]], fp);
	}
	else {
	  (void)fputc((int)(c1 | 0x80), fp);
	  (void)fputc((int)(c2 | 0x80), fp);
	}
	break;
      case JS_JIS7:	/* 1byte Ҳ̾	*/
      case JS_JIS8:	/* 1byte Ҳ̾	*/
	c1 = GetChar();
	(void)fputc((int)code2euc_map[kana2code_map[c].b1], fp);
	if (c1 == 0xde || c1 == 0x5e) {		/* 		*/
	  (void)fputc((int)code2euc_map[kana2code_map[c].b2 + 1], fp);
	}
	else if (c1 == 0xdf || c1 == 0x5f) {	/* Ⱦ	*/
	  (void)fputc((int)code2euc_map[kana2code_map[c].b2 + 2], fp);
	}
	else {
	  (void)fputc((int)code2euc_map[kana2code_map[c].b2], fp);
	  UngetChar(c1);
	}
	break;
      default:
	break;
    }
  }
}

/*
 * ؿ̾:	jis2sjis
 * ǽ:	JIS ɤ SJIS ɤѴ
 * :	ϥե롦ݥ
 * :	ʤ
 */
void jis2sjis(fp)
	register FILE	*fp;
{
  int		c, c1, c2;
  StateJIS	state = JS_ASCII;

  while ((c = GetChar()) != EOF) {
    if (c == ESC) {
      state = GetStateOfJIS();
      continue;
    }
    if (c == SO) {	/* Shift Out ν		*/
      state = JS_JIS7;
      c = GetChar();
    }
    else if (c == SI) {	/* Shift In ν		*/
      state = JS_ASCII;
    }
    switch (state) {
      case JS_ASCII:
	if (c == LF) {
	  (void)fputs(lineend, fp);
	}
	else {
	  (void)fputc(c, fp);
	}
	break;
      case JS_JIS_2BYTE:
	c1 = c;		/* JIS 裱Х	*/
	c2 = GetChar();	/* JIS 裲Х	*/
	if (zen2ascii && (jis2code_map[c1] == 0x03)) {
	  (void)fputc(c2, fp);
	}
	else {
	  if (c1 % 2 == 0) {
	    (void)fputc((int)code2sjis_map1[jis2code_map[c1]], fp);
	    (void)fputc((int)code2sjis_map2_e[jis2code_map[c2]], fp);
	  }
	  else {
	    (void)fputc((int)code2sjis_map1[jis2code_map[c1]], fp);
	    (void)fputc((int)code2sjis_map2_o[jis2code_map[c2]], fp);
	  }
	}
	break;
      case JS_JIS7:	/* 1byte Ҳ̾	*/
      case JS_JIS8:	/* 1byte Ҳ̾	*/
	c1 = GetChar();
	(void)fputc((int)code2sjis_map1[kana2code_map[c].b1], fp);
	if (c1 == 0xde || c1 == 0x5e) {		/* 		*/
	  (void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2 + 1], fp);
	}
	else if (c1 == 0xdf || c1 == 0x5f) {	/* Ⱦ	*/
	  (void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2 + 2], fp);
	}
	else {
	  (void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2], fp);
	  UngetChar(c1);
	}
	break;
      default:
	break;
    }
  }
}

/*
 * ؿ̾:	euc2jis
 * ǽ:	ܸ EUC ɤ JIS ɤѴ
 * :	ϥե롦ݥ
 * :	ʤ
 */
void euc2jis(fp)
	register FILE	*fp;
{
  int		c, c1, c2;
  State		state = UNKNOWN_STATE;

  while ((c = GetChar()) != EOF) {
euc2jis_loop:
    if (IsCTRL(c) || IsASCII(c)) {
      if (state == JIS_STATE) {
	(void)fprintf(fp, "%s", ES_ASCII);
	state = ASCII_STATE;
      }
      if (c == LF) {
	(void)fputs(lineend, fp);
      }
      else {
	(void)fputc(c, fp);
      }
    }
    else if (c == SS2) {
      if (state != JIS_STATE) {
	(void)fprintf(fp, "%s", ES_NEWJIS);
	state = JIS_STATE;
      }
      c  = GetChar();
      c1 = GetChar();
      if (c1 == SS2) {
	c2 = GetChar();
	(void)fputc((int)code2jis_map[kana2code_map[c].b1], fp);
	if (c2 == 0xde) {	/* 		*/
	  (void)fputc((int)code2jis_map[kana2code_map[c].b2 + 1], fp);
	}
	else if (c2 == 0xdf) {	/* Ⱦ	*/
	  (void)fputc((int)code2jis_map[kana2code_map[c].b2 + 2], fp);
	}
	else {
	  (void)fputc((int)code2jis_map[kana2code_map[c].b2], fp);
	  UngetChar(c2);
	  c = c1;
	  goto euc2jis_loop;
	}
      }
      else {
	(void)fputc((int)code2jis_map[kana2code_map[c].b1], fp);
	(void)fputc((int)code2jis_map[kana2code_map[c].b2], fp);
	UngetChar(c1);
      }
    }
    else if (IsEUC(c)) {
      c1 = c;		/* ܸ EUC 裱Х	*/
      c2 = GetChar();	/* ܸ EUC 裲Х	*/
      if (zen2ascii && (euc2code_map[c1] == 0x03)) {
	if (state != ASCII_STATE) {
	  (void)fprintf(fp, "%s", ES_ASCII);
	  state = ASCII_STATE;
	}
	(void)fputc((int)zen2ascii_map[euc2code_map[c2]], fp);
      }
      else {
	if (state != JIS_STATE) {
	  (void)fprintf(fp, "%s", ES_NEWJIS);
	  state = JIS_STATE;
	}
	(void)fputc((c1 & 0x7f), fp);
	(void)fputc((c2 & 0x7f), fp);
      }
    }
    else {	/* ΤϤΤǤΤޤ޽	*/
      (void)fputc(c, fp);
    }
  }
}

/*
 * ؿ̾:	euc2sjis
 * ǽ:	ܸ EUC ɤ SJIS ɤѴ
 * :	ϥե롦ݥ
 * :	ʤ
 */
void euc2sjis(fp)
	register FILE	*fp;
{
  int	c, c1, c2;

  while ((c = GetChar()) != EOF) {
euc2sjis_loop:
    if (IsCTRL(c) || IsASCII(c)) {
      if (c == LF) {
	(void)fputs(lineend, fp);
      }
      else {
	(void)fputc(c, fp);
      }
    }
    else if (c == SS2) {
      c  = GetChar();
      c1 = GetChar();
      if (c1 == SS2) {
	c2 = GetChar();
	(void)fputc((int)code2sjis_map1[kana2code_map[c].b1], fp);
	if (c2 == 0xde) {	/* 		*/
	  (void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2 + 1], fp);
	}
	else if (c2 == 0xdf) {	/* Ⱦ	*/
	  (void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2 + 2], fp);
	}
	else {
	  (void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2], fp);
	  UngetChar(c2);
	  c = c1;
	  goto euc2sjis_loop;
	}
      }
      else {
	(void)fputc((int)code2sjis_map1[kana2code_map[c].b1], fp);
	(void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2], fp);
	UngetChar(c1);
      }
    }
    else if (IsEUC(c)) {
      c1 = c;		/* ܸ EUC 裱Х	*/
      c2 = GetChar();	/* ܸ EUC 裲Х	*/
      if (zen2ascii && (euc2code_map[c1] == 0x03)) {
	(void)fputc((int)zen2ascii_map[euc2code_map[c2]], fp);
      }
      else {
	if (c1 % 2 == 0) {
	  (void)fputc((int)code2sjis_map1[euc2code_map[c1]], fp);
	  (void)fputc((int)code2sjis_map2_e[euc2code_map[c2]], fp);
	}
	else {
	  (void)fputc((int)code2sjis_map1[euc2code_map[c1]], fp);
	  (void)fputc((int)code2sjis_map2_o[euc2code_map[c2]], fp);
	}
      }
    }
    else {	/* ΤϤΤǤΤޤ޽	*/
      (void)fputc(c, fp);
    }
  }
}

/*
 * ؿ̾:	sjis2euc
 * ǽ:	SJIS ɤܸ EUC ɤѴ
 * :	ϥե롦ݥ
 * :	ʤ
 */
void sjis2euc(fp)
	register FILE	*fp;
{
  int	c, c1, c2;

  while ((c = GetChar()) != EOF) {
    if (IsCTRL(c) || IsASCII(c)) {
      if (c == LF) {
	(void)fputs(lineend, fp);
      }
      else {
	(void)fputc(c, fp);
      }
    }
    else if (IsKANA8(c)) {
      c1 = GetChar();
      (void)fputc((int)code2euc_map[kana2code_map[c].b1], fp);
      if (c1 == 0xde) {		/* 		*/
	(void)fputc((int)code2euc_map[kana2code_map[c].b2 + 1], fp);
      }
      else if (c1 == 0xdf) {	/* Ⱦ	*/
	(void)fputc((int)code2euc_map[kana2code_map[c].b2 + 2], fp);
      }
      else {
	(void)fputc((int)code2euc_map[kana2code_map[c].b2], fp);
	UngetChar(c1);
      }
    }
    else if (IsSJIS1(c)) {
      c1 = c;		/* SJIS 裱Х	*/
      c2 = GetChar();	/* SJIS 裲Х	*/
      if ((c2 >= 0x40 && c2 <= 0x7e) ||
	  (c2 >= 0x80 && c2 <= 0x9e)) {
	if (zen2ascii && (sjis2code_map1_l[c1] == 0x03)) {
	  (void)fputc((int)zen2ascii_map[sjis2code_map2[c2]], fp);
	}
	else {
	  (void)fputc((int)code2euc_map[sjis2code_map1_l[c1]], fp);
	  (void)fputc((int)code2euc_map[sjis2code_map2[c2]], fp);
	}
      }
      else if (c2 >= 0x9f && c2 <= 0xfc) {
	if (zen2ascii && (sjis2code_map1_r[c1] == 0x03)) {
	  (void)fputc((int)zen2ascii_map[sjis2code_map2[c2]], fp);
	}
	else {
	  (void)fputc((int)code2euc_map[sjis2code_map1_r[c1]], fp);
	  (void)fputc((int)code2euc_map[sjis2code_map2[c2]], fp);
	}
      }
    }
    else {	/* ΤϤΤǤΤޤ޽	*/
      (void)fputc(c, fp);
    }
  }
}

/*
 * ؿ̾:	sjis2jis
 * ǽ:	SJIS ɤ JIS ɤѴ
 * :	ϥե롦ݥ
 * :	ʤ
 */
void sjis2jis(fp)
	register FILE	*fp;
{
  int		c, c1, c2;
  State		state = UNKNOWN_STATE;

  while ((c = GetChar()) != EOF) {
    if (IsCTRL(c) || IsASCII(c)) {
      if (state != ASCII_STATE) {
	(void)fprintf(fp, "%s", ES_ASCII);
	state = ASCII_STATE;
      }
      if (c == LF) {
	(void)fputs(lineend, fp);
      }
      else {
	(void)fputc(c, fp);
      }
    }
    else if (IsKANA8(c)) {
      if (state != JIS_STATE) {
	(void)fprintf(fp, "%s", ES_NEWJIS);
	state = JIS_STATE;
      }
      c1 = GetChar();
      (void)fputc((int)code2jis_map[kana2code_map[c].b1], fp);
      if (c1 == 0xde) {		/* 		*/
	(void)fputc((int)code2jis_map[kana2code_map[c].b2 + 1], fp);
      }
      else if (c1 == 0xdf) {	/* Ⱦ	*/
	(void)fputc((int)code2jis_map[kana2code_map[c].b2 + 2], fp);
      }
      else {
	(void)fputc((int)code2jis_map[kana2code_map[c].b2], fp);
	UngetChar(c1);
      }
    }
    else if (IsSJIS1(c)) {
      c1 = c;		/* SJIS 裱Х	*/
      c2 = GetChar();	/* SJIS 裲Х	*/
      if ((c2 >= 0x40 && c2 <= 0x7e) ||
	  (c2 >= 0x80 && c2 <= 0x9e)) {
	if (zen2ascii && (sjis2code_map1_l[c1] == 0x03)) {
	  if (state != ASCII_STATE) {
	    (void)fprintf(fp, "%s", ES_ASCII);
	    state = ASCII_STATE;
	  }
	  (void)fputc((int)zen2ascii_map[sjis2code_map2[c2]], fp);
	}
	else {
	  if (state != JIS_STATE) {
	    (void)fprintf(fp, "%s", ES_NEWJIS);
	    state = JIS_STATE;
	  }
	  (void)fputc((int)code2jis_map[sjis2code_map1_l[c1]], fp);
	  (void)fputc((int)code2jis_map[sjis2code_map2[c2]], fp);
	}
      }
      else if (c2 >= 0x9f && c2 <= 0xfc) {
	if (zen2ascii && (sjis2code_map1_r[c1] == 0x03)) {
	  if (state != ASCII_STATE) {
	    (void)fprintf(fp, "%s", ES_ASCII);
	    state = ASCII_STATE;
	  }
	  (void)fputc((int)zen2ascii_map[sjis2code_map2[c2]], fp);
	}
	else {
	  if (state != JIS_STATE) {
	    (void)fprintf(fp, "%s", ES_NEWJIS);
	    state = JIS_STATE;
	  }
	  (void)fputc((int)code2jis_map[sjis2code_map1_r[c1]], fp);
	  (void)fputc((int)code2jis_map[sjis2code_map2[c2]], fp);
	}
      }
    }
    else {	/* ΤϤΤǤΤޤ޽	*/
      (void)fputc(c, fp);
    }
  }
}

/*
 * ؿ̾:	jis2jis
 * ǽ:	JIS ɤ 1byte Ҳ̾ 2byte Ҳ̾Ѵ
 * :	ϥե롦ݥ
 * :	ʤ
 */
void jis2jis(fp)
	register FILE	*fp;
{
  int		c, c1, c2;
  StateJIS	state, pre_state;
  Boolean	zen2ascii_mode = FALSE;

  state = pre_state = JS_ASCII;
  while ((c = GetChar()) != EOF) {
    if (c == ESC) {		/* ץ󥹤ν	*/
      state = GetStateOfJIS();
      continue;
    }
    if (c == SO) {		/* Shift Out ν		*/
      state = JS_JIS7;
      c = GetChar();
    }
    else if (c == SI) {		/* Shift In ν		*/
      state = JS_ASCII;
    }
    if (state != pre_state) {	/* Ѳ			*/
      switch (state) {
	case JS_ASCII:
	  (void)fprintf(fp, "%s", ES_ASCII);
	  break;
	case JS_JIS_2BYTE:
	case JS_JIS7:
	case JS_JIS8:
	  (void)fprintf(fp, "%s", ES_NEWJIS);
	  break;
	default:
	  break;
      }
    }
    pre_state = state;

    switch (state) {
      case JS_ASCII:
	if (c == LF) {
	  (void)fputs(lineend, fp);
	}
	else {
	  (void)fputc(c, fp);
	}
	break;
      case JS_JIS_2BYTE:
	c1 = c;
	c2 = GetChar();
	if (zen2ascii && (jis2code_map[c1] == 0x03)) {
	  if (!zen2ascii_mode) {
	    (void)fprintf(fp, "%s", ES_ASCII);
	    zen2ascii_mode = TRUE;
	  }
	  (void)fputc((int)zen2ascii_map[jis2code_map[c2]], fp);
	}
	else {
	  if (zen2ascii_mode) {
	    (void)fprintf(fp, "%s", ES_NEWJIS);
	    zen2ascii_mode = FALSE;
	  }
	  (void)fputc(c1, fp);
	  (void)fputc(c2, fp);
	}
	break;
      case JS_JIS7:
      case JS_JIS8:
	c1 = GetChar();
	(void)fputc((int)code2jis_map[kana2code_map[c].b1], fp);
	if (c1 == 0xde || c1 == 0x5e) {		/* 		*/
	  (void)fputc((int)code2jis_map[kana2code_map[c].b2 + 1], fp);
	}
	else if (c1 == 0xdf || c1 == 0x5f) {	/* Ⱦ	*/
	  (void)fputc((int)code2jis_map[kana2code_map[c].b2 + 2], fp);
	}
	else {
	  (void)fputc((int)code2jis_map[kana2code_map[c].b2], fp);
	  UngetChar(c1);
	}
	break;
      default:
	break;
    }
  }
}

/*
 * ؿ̾:	euc2euc
 * ǽ:	ܸ EUC ɤ 1byte Ҳ̾ 2byte Ҳ̾Ѵ
 * :	ϥե롦ݥ
 * :	ʤ
 */
void euc2euc(fp)
	register FILE	*fp;
{
  int	c, c1, c2;

  while ((c = GetChar()) != EOF) {
euc2euc_loop:
    if (IsCTRL(c) || IsASCII(c)) {
      if (c == LF) {
	(void)fputs(lineend, fp);
      }
      else {
	(void)fputc(c, fp);
      }
    }
    else if (c == SS2) {
      c  = GetChar();
      c1 = GetChar();
      if (c1 == SS2) {
	c2 = GetChar();
	(void)fputc((int)code2euc_map[kana2code_map[c].b1], fp);
	if (c2 == 0xde) {	/* 		*/
	  (void)fputc((int)code2euc_map[kana2code_map[c].b2 + 1], fp);
	}
	else if (c2 == 0xdf) {	/* Ⱦ	*/
	  (void)fputc((int)code2euc_map[kana2code_map[c].b2 + 2], fp);
	}
	else {
	  (void)fputc((int)code2euc_map[kana2code_map[c].b2], fp);
	  UngetChar(c2);
	  c = c1;
	  goto euc2euc_loop;
	}
      }
      else {
	(void)fputc((int)code2euc_map[kana2code_map[c].b1], fp);
	(void)fputc((int)code2euc_map[kana2code_map[c].b2], fp);
	UngetChar(c1);
      }
    }
    else if (IsEUC(c)) {
      c1 = c;
      c2 = GetChar();
      if (zen2ascii && (euc2code_map[c1] == 0x03)) {
	(void)fputc((int)zen2ascii_map[euc2code_map[c2]], fp);
      }
      else {
        (void)fputc(c1, fp);
        (void)fputc(c2, fp);
      }
    }
  }
}

/*
 * ؿ̾:	sjis2sjis
 * ǽ:	SJIS ɤ 1byte Ҳ̾ 2byte Ҳ̾Ѵ
 * :	ϥե롦ݥ
 * :	ʤ
 */
void sjis2sjis(fp)
	register FILE	*fp;
{
  int	c, c1, c2;

  while ((c = GetChar()) != EOF) {
    if (IsCTRL(c) || IsASCII(c)) {
      if (c == LF) {
	(void)fputs(lineend, fp);
      }
      else {
	(void)fputc(c, fp);
      }
    }
    else if (IsKANA8(c)) {
      c1 = GetChar();
      (void)fputc((int)code2sjis_map1[kana2code_map[c].b1], fp);
      if (c1 == 0xde) {		/* 		*/
	(void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2 + 1], fp);
      }
      else if (c1 == 0xdf) {	/* Ⱦ	*/
	(void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2 + 2], fp);
      }
      else {
	(void)fputc((int)code2sjis_map2_o[kana2code_map[c].b2], fp);
	UngetChar(c1);
      }
    }
    else if (IsSJIS1(c)) {
      c1 = c;		/* SJIS 裱Х	*/
      c2 = GetChar();	/* SJIS 裲Х	*/
      if ((c2 >= 0x40 && c2 <= 0x7e) ||
	  (c2 >= 0x80 && c2 <= 0x9e)) {
	if (zen2ascii && (sjis2code_map1_l[c1] == 0x03)) {
	  (void)fputc((int)zen2ascii_map[sjis2code_map2[c2]], fp);
	}
	else {
          (void)fputc(c1, fp);
          (void)fputc(c2, fp);
	}
      }
      else if (c2 >= 0x9f && c2 <= 0xfc) {
	if (zen2ascii && (sjis2code_map1_r[c1] == 0x03)) {
	  (void)fputc((int)zen2ascii_map[sjis2code_map2[c2]], fp);
	}
	else {
          (void)fputc(c1, fp);
          (void)fputc(c2, fp);
	}
      }
    }
  }
}

/*
 * ؿ̾:	NoConv
 * ǽ:	Ѵʤǽ
 * :	ե롦ݥ
 * :	ʤ
 */
void NoConv(fp)
        register FILE	*fp;
{
  int   c;

  while ((c = GetChar()) != EOF) {
    (void)fputc(c, fp);
  }
}

